// CLN exported types and functions

#ifndef _CLN_H
#define _CLN_H

// Automatically generated by configure
//#include "cl_config.h"      // included by "cl_types.h" below
//#include "cl_intparam.h"    // included by "cl_types.h" below
//#include "cl_floatparam.h"  // not needed by any public header file

// ============================== base ==============================

// Basic types and definitions.
#include "cl_types.h"
#include "cl_modules.h"
#include "cl_object.h"

// Miscellaneous.
#include "cl_random.h"
#include "cl_malloc.h"
#include "cl_abort.h"
#include "cl_floatformat.h"
#include "cl_io.h"
#include "cl_condition.h"

// Symbolic facilities.
#include "cl_string.h"
#include "cl_symbol.h"
#include "cl_proplist.h"

// Miscellaneous.
#include "cl_input.h"
#include "cl_output.h"

// Abstract number classes.
#include "cl_number.h"
#include "cl_number_io.h"
#include "cl_complex_class.h"
#include "cl_real_class.h"
#include "cl_rational_class.h"

// Rings.
#include "cl_ring.h"

// ============================== integer ==============================

// Integers.
#include "cl_integer_class.h"
#include "cl_integer.h"
#include "cl_integer_io.h"
#include "cl_integer_ring.h"
#include "cl_null_ring.h"

// ============================== rational ==============================

// Rational numbers.
#include "cl_rational.h"
#include "cl_rational_io.h"
#include "cl_rational_ring.h"

// ============================== float ==============================

// Floating-point numbers.
#include "cl_float_class.h"
#include "cl_sfloat_class.h"
#include "cl_ffloat_class.h"
#include "cl_dfloat_class.h"
#include "cl_lfloat_class.h"
#include "cl_float.h"
#include "cl_float_io.h"
#include "cl_sfloat.h"
#include "cl_sfloat_io.h"
#include "cl_ffloat.h"
#include "cl_ffloat_io.h"
#include "cl_dfloat.h"
#include "cl_dfloat_io.h"
#include "cl_lfloat.h"
#include "cl_lfloat_io.h"

// ============================== real ==============================

// Real numbers.
#include "cl_real.h"
#include "cl_real_io.h"
#include "cl_real_ring.h"

// ============================== complex ==============================

// Complex numbers.
#include "cl_complex.h"
#include "cl_complex_io.h"
#include "cl_complex_ring.h"

// ============================== modinteger ==============================

// Modular integers.
#include "cl_modinteger.h"

// ============================== numtheory ==============================

// Rings for number theory.
#include "cl_numtheory.h"

// ============================== vector ==============================

// Vectors.
#include "cl_V.h"
#include "cl_GV.h"
#include "cl_GV_number.h"
#include "cl_GV_complex.h"
#include "cl_GV_real.h"
#include "cl_GV_rational.h"
#include "cl_GV_integer.h"
#include "cl_GV_modinteger.h"
#include "cl_SV.h"
#include "cl_SV_number.h"
#include "cl_SV_complex.h"
#include "cl_SV_real.h"
#include "cl_SV_rational.h"
#include "cl_SV_integer.h"
#include "cl_SV_ringelt.h"

// ============================== polynomial ==============================

// Polynomials.
#include "cl_univpoly.h"
#include "cl_univpoly_complex.h"
#include "cl_univpoly_real.h"
#include "cl_univpoly_rational.h"
#include "cl_univpoly_integer.h"
#include "cl_univpoly_modint.h"

// ============================== modpolynomial ==============================

// ============================== timing ==============================

// Environmental facilities.
#include "cl_timing.h"

#endif /* _CLN_H */

